#!/usr/bin/perl
#use strict;
require 5.6.0;
use warnings 'all';

use Cwd qw( realpath getcwd);
use File::Basename;
use File::Spec;
use Config;
## 28-01-2014 : Updated for ALU01944556 ####
## 28-09-2016 : ALU02278259

my $scriptDir;
BEGIN {
$scriptDir = dirname(realpath($0));
my $perlLibLocation = "standalone";

###----
  if(defined($ENV{'LOAD_PERL_LIBS_LOCATION'})) {
       $perlLibLocation = $ENV{'LOAD_PERL_LIBS_LOCATION'};
  }

  if ($Config{archname} =~ /sun4/) {
                unshift(@INC, "$scriptDir/lib-perl/$perlLibLocation/sun4-solaris-64int");
  } elsif ($Config{archname} =~ /i86pc/) {
                unshift(@INC, "$scriptDir/lib-perl/$perlLibLocation/i86pc-solaris-64int");
  } elsif ($Config{archname} =~ /i386-linux-thread-multi/) {
                unshift(@INC, "$scriptDir/lib-perl/$perlLibLocation/i386-linux-thread-multi");
  } elsif ($Config{archname} =~ /x86_64-linux-thread-multi/) {
                if($Config{version} =~ /(\d+)\.(\d{1,2})/) {
                   my $perlVersion = ($1 *100 + $2);
                   if( $perlVersion < 510) {
                      unshift(@INC, "$scriptDir/lib-perl/$perlLibLocation/x86_64-linux-thread-multi/5.8");
                   } elsif($perlVersion < 516) {
                      unshift(@INC, "$scriptDir/lib-perl/$perlLibLocation/x86_64-linux-thread-multi/5.10/");
                   } else {
                      unshift(@INC, "$scriptDir/lib-perl/$perlLibLocation/x86_64-linux-thread-multi/5.16/");
                   }
                }
  }
  unshift(@INC, "$scriptDir/lib-perl/$perlLibLocation");
}

use lib "$scriptDir/lib";

###----
###unshift(@INC, "$scriptDir/lib-perl/$perlLibLocation/sun4-solaris-64int");
###unshift(@INC, "$scriptDir/lib-perl/$perlLibLocation");
###}

use lib "$scriptDir/lib";

use Net::SFTP::Foreign;
#use Net::SFTP::Util qw( fx2txt );

sub usage{
print 'Usage sftpClient.pl with the following parameters \n"
        1) User Name 
        2) Password 
        3) Ip of the remote server, 
        4) Source|Destination file (src1|dest1#src2|dest2#...#srcn|destn)
        5) Option get/put 
';
    exit 1;
}

my $user=$ARGV[0];
my $password=$ARGV[1];

my $destination=$ARGV[2];
my $files=$ARGV[3];
my $option=$ARGV[4];
#
# program starts here
#

#if (($user eq "") || ($password eq "") || ($destination eq "") || ($files eq "") || ($option eq "")) {
if (!defined($user) || !defined($password) || !defined($destination) || !defined($files) || !defined($option)) {
    print "Input parameters cannot be empty \n";
    usage();
}
my @listFiles = split('#', $files);
my $listFailed;
my @listFile;
my $status=0;
my $err = "";
my $ret;

if ($option ne "get" and $option ne "put"){
    print "Don't know option $option \n";
    usage();
}
my %args = (user => "$user", password => "$password");

#$args{debug} = 0;
#$args{warn} = 0;

my $sftp=Net::SFTP::Foreign->new($destination, %args) or die "could not open connection to $destination\n";
foreach my $file (@listFiles){
    @listFile = split ('\|', $file);
    eval {
        $ret=$sftp->$option($listFile[0], $listFile[1], copy_perm => 0, copy_time => 0);
    };
    if ($@) {
        $err = $@;
        $err =~ s/.*: (.*) at .*/$1/;
        chomp($err);
    }
    if(not defined $ret){
        my $err .= $sftp->error();
        print STDERR "ERROR : $err\n";
        $status=1;
        if (not defined $listFailed){
            $listFailed = $listFile[0] ."|" . $err;
        }else{
            $listFailed = $listFailed ."%" . $listFile[0] ."|" . $err;
        }
    }
}
exit $status;
